Index: uspace/lib/gui/terminal.c
===================================================================
--- uspace/lib/gui/terminal.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/gui/terminal.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,5 +47,4 @@
 #include <atomic.h>
 #include <stdarg.h>
-#include <str.h>
 #include "window.h"
 #include "terminal.h"
@@ -63,14 +62,14 @@
 static LIST_INITIALIZE(terms);
 
-static errno_t term_open(con_srvs_t *, con_srv_t *);
-static errno_t term_close(con_srv_t *);
-static errno_t term_read(con_srv_t *, void *, size_t, size_t *);
-static errno_t term_write(con_srv_t *, void *, size_t, size_t *);
+static int term_open(con_srvs_t *, con_srv_t *);
+static int term_close(con_srv_t *);
+static int term_read(con_srv_t *, void *, size_t);
+static int term_write(con_srv_t *, void *, size_t);
 static void term_sync(con_srv_t *);
 static void term_clear(con_srv_t *);
 static void term_set_pos(con_srv_t *, sysarg_t col, sysarg_t row);
-static errno_t term_get_pos(con_srv_t *, sysarg_t *, sysarg_t *);
-static errno_t term_get_size(con_srv_t *, sysarg_t *, sysarg_t *);
-static errno_t term_get_color_cap(con_srv_t *, console_caps_t *);
+static int term_get_pos(con_srv_t *, sysarg_t *, sysarg_t *);
+static int term_get_size(con_srv_t *, sysarg_t *, sysarg_t *);
+static int term_get_color_cap(con_srv_t *, console_caps_t *);
 static void term_set_style(con_srv_t *, console_style_t);
 static void term_set_color(con_srv_t *, console_color_t, console_color_t,
@@ -78,5 +77,5 @@
 static void term_set_rgb_color(con_srv_t *, pixel_t, pixel_t);
 static void term_set_cursor_visibility(con_srv_t *, bool);
-static errno_t term_get_event(con_srv_t *, cons_event_t *);
+static int term_get_event(con_srv_t *, cons_event_t *);
 
 static con_ops_t con_ops = {
@@ -377,15 +376,15 @@
 }
 
-static errno_t term_open(con_srvs_t *srvs, con_srv_t *srv)
+static int term_open(con_srvs_t *srvs, con_srv_t *srv)
 {
 	return EOK;
 }
 
-static errno_t term_close(con_srv_t *srv)
+static int term_close(con_srv_t *srv)
 {
 	return EOK;
 }
 
-static errno_t term_read(con_srv_t *srv, void *buf, size_t size, size_t *nread)
+static int term_read(con_srv_t *srv, void *buf, size_t size)
 {
 	terminal_t *term = srv_to_terminal(srv);
@@ -432,6 +431,5 @@
 	}
 	
-	*nread = size;
-	return EOK;
+	return size;
 }
 
@@ -464,5 +462,5 @@
 }
 
-static errno_t term_write(con_srv_t *srv, void *data, size_t size, size_t *nwritten)
+static int term_write(con_srv_t *srv, void *data, size_t size)
 {
 	terminal_t *term = srv_to_terminal(srv);
@@ -472,49 +470,48 @@
 		term_write_char(term, str_decode(data, &off, size));
 	
-	*nwritten = size;
+	return size;
+}
+
+static void term_sync(con_srv_t *srv)
+{
+	terminal_t *term = srv_to_terminal(srv);
+	
+	term_update(term);
+}
+
+static void term_clear(con_srv_t *srv)
+{
+	terminal_t *term = srv_to_terminal(srv);
+	
+	fibril_mutex_lock(&term->mtx);
+	chargrid_clear(term->frontbuf);
+	fibril_mutex_unlock(&term->mtx);
+	
+	term_update(term);
+}
+
+static void term_set_pos(con_srv_t *srv, sysarg_t col, sysarg_t row)
+{
+	terminal_t *term = srv_to_terminal(srv);
+	
+	fibril_mutex_lock(&term->mtx);
+	chargrid_set_cursor(term->frontbuf, col, row);
+	fibril_mutex_unlock(&term->mtx);
+	
+	term_update(term);
+}
+
+static int term_get_pos(con_srv_t *srv, sysarg_t *col, sysarg_t *row)
+{
+	terminal_t *term = srv_to_terminal(srv);
+	
+	fibril_mutex_lock(&term->mtx);
+	chargrid_get_cursor(term->frontbuf, col, row);
+	fibril_mutex_unlock(&term->mtx);
+	
 	return EOK;
 }
 
-static void term_sync(con_srv_t *srv)
-{
-	terminal_t *term = srv_to_terminal(srv);
-	
-	term_update(term);
-}
-
-static void term_clear(con_srv_t *srv)
-{
-	terminal_t *term = srv_to_terminal(srv);
-	
-	fibril_mutex_lock(&term->mtx);
-	chargrid_clear(term->frontbuf);
-	fibril_mutex_unlock(&term->mtx);
-	
-	term_update(term);
-}
-
-static void term_set_pos(con_srv_t *srv, sysarg_t col, sysarg_t row)
-{
-	terminal_t *term = srv_to_terminal(srv);
-	
-	fibril_mutex_lock(&term->mtx);
-	chargrid_set_cursor(term->frontbuf, col, row);
-	fibril_mutex_unlock(&term->mtx);
-	
-	term_update(term);
-}
-
-static errno_t term_get_pos(con_srv_t *srv, sysarg_t *col, sysarg_t *row)
-{
-	terminal_t *term = srv_to_terminal(srv);
-	
-	fibril_mutex_lock(&term->mtx);
-	chargrid_get_cursor(term->frontbuf, col, row);
-	fibril_mutex_unlock(&term->mtx);
-	
-	return EOK;
-}
-
-static errno_t term_get_size(con_srv_t *srv, sysarg_t *cols, sysarg_t *rows)
+static int term_get_size(con_srv_t *srv, sysarg_t *cols, sysarg_t *rows)
 {
 	terminal_t *term = srv_to_terminal(srv);
@@ -528,5 +525,5 @@
 }
 
-static errno_t term_get_color_cap(con_srv_t *srv, console_caps_t *caps)
+static int term_get_color_cap(con_srv_t *srv, console_caps_t *caps)
 {
 	(void) srv;
@@ -576,5 +573,5 @@
 }
 
-static errno_t term_get_event(con_srv_t *srv, cons_event_t *event)
+static int term_get_event(con_srv_t *srv, cons_event_t *event)
 {
 	terminal_t *term = srv_to_terminal(srv);
@@ -752,5 +749,5 @@
 	term->srvs.sarg = term;
 	
-	errno_t rc = loc_server_register(NAME);
+	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
 		widget_deinit(&term->widget);
Index: uspace/lib/gui/terminal.h
===================================================================
--- uspace/lib/gui/terminal.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/gui/terminal.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,5 +45,4 @@
 #include <adt/prodcons.h>
 #include <atomic.h>
-#include <str.h>
 #include "widget.h"
 
Index: uspace/lib/gui/window.c
===================================================================
--- uspace/lib/gui/window.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/gui/window.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -163,5 +163,5 @@
 	
 	font_t *font;
-	errno_t rc = embedded_font_create(&font, 16);
+	int rc = embedded_font_create(&font, 16);
 	if (rc != EOK) {
 		window_yield(widget->window);
@@ -404,5 +404,5 @@
 	
 	/* Inform compositor about new surface. */
-	errno_t rc = win_resize(win->osess, offset_x, offset_y, width, height,
+	int rc = win_resize(win->osess, offset_x, offset_y, width, height,
 	    placement_flags, surface_direct_access(new_surface));
 	
@@ -493,5 +493,5 @@
 
 /* Window event loop. Runs in own dedicated fibril. */
-static errno_t event_loop(void *arg)
+static int event_loop(void *arg)
 {
 	bool is_main = false;
@@ -561,7 +561,7 @@
 
 /* Input fetcher from compositor. Runs in own dedicated fibril. */
-static errno_t fetch_input(void *arg)
-{
-	errno_t rc;
+static int fetch_input(void *arg)
+{
+	int rc;
 	bool terminate = false;
 	window_t *win = (window_t *) arg;
@@ -618,5 +618,5 @@
 	
 	service_id_t reg_dsid;
-	errno_t rc = loc_service_get_id(winreg, &reg_dsid, 0);
+	int rc = loc_service_get_id(winreg, &reg_dsid, 0);
 	if (rc != EOK) {
 		free(win);
@@ -677,5 +677,5 @@
 }
 
-errno_t window_set_caption(window_t *win, const char *caption)
+int window_set_caption(window_t *win, const char *caption)
 {
 	char *cap;
Index: uspace/lib/gui/window.h
===================================================================
--- uspace/lib/gui/window.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/gui/window.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -78,5 +78,5 @@
 
 /** Change window caption. */
-extern errno_t window_set_caption(window_t *, const char *);
+extern int window_set_caption(window_t *, const char *);
 
 /**
Index: uspace/lib/hound/include/hound/client.h
===================================================================
--- uspace/lib/hound/include/hound/client.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/hound/include/hound/client.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,20 +47,20 @@
 typedef struct hound_stream hound_stream_t;
 
-hound_context_t *hound_context_create_playback(const char *name,
+hound_context_t * hound_context_create_playback(const char *name,
     pcm_format_t format, size_t bsize);
-hound_context_t *hound_context_create_capture(const char *name,
+hound_context_t * hound_context_create_capture(const char *name,
     pcm_format_t format, size_t bsize);
 void hound_context_destroy(hound_context_t *hound);
 
-errno_t hound_context_set_main_stream_params(hound_context_t *hound,
+int hound_context_set_main_stream_params(hound_context_t *hound,
     pcm_format_t format, size_t bsize);
 
-errno_t hound_context_get_available_targets(hound_context_t *hound,
-    char ***names, size_t *count);
-errno_t hound_context_get_connected_targets(hound_context_t *hound,
-    char ***names, size_t *count);
+int hound_context_get_available_targets(hound_context_t *hound,
+    const char ***names, size_t *count);
+int hound_context_get_connected_targets(hound_context_t *hound,
+    const char ***names, size_t *count);
 
-errno_t hound_context_connect_target(hound_context_t *hound, const char *target);
-errno_t hound_context_disconnect_target(hound_context_t *hound, const char *target);
+int hound_context_connect_target(hound_context_t *hound, const char* target);
+int hound_context_disconnect_target(hound_context_t *hound, const char* target);
 
 hound_stream_t *hound_stream_create(hound_context_t *hound, unsigned flags,
@@ -68,14 +68,14 @@
 void hound_stream_destroy(hound_stream_t *stream);
 
-errno_t hound_stream_write(hound_stream_t *stream, const void *data, size_t size);
-errno_t hound_stream_read(hound_stream_t *stream, void *data, size_t size);
-errno_t hound_stream_drain(hound_stream_t *stream);
+int hound_stream_write(hound_stream_t *stream, const void *data, size_t size);
+int hound_stream_read(hound_stream_t *stream, void *data, size_t size);
+int hound_stream_drain(hound_stream_t *stream);
 
-errno_t hound_write_main_stream(hound_context_t *hound,
+int hound_write_main_stream(hound_context_t *hound,
     const void *data, size_t size);
-errno_t hound_read_main_stream(hound_context_t *hound, void *data, size_t size);
-errno_t hound_write_replace_main_stream(hound_context_t *hound,
+int hound_read_main_stream(hound_context_t *hound, void *data, size_t size);
+int hound_write_replace_main_stream(hound_context_t *hound,
     const void *data, size_t size);
-errno_t hound_write_immediate(hound_context_t *hound,
+int hound_write_immediate(hound_context_t *hound,
     pcm_format_t format, const void *data, size_t size);
 
Index: uspace/lib/hound/include/hound/protocol.h
===================================================================
--- uspace/lib/hound/include/hound/protocol.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/hound/include/hound/protocol.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,12 +58,22 @@
 typedef intptr_t hound_context_id_t;
 
+/**
+ * Check context id for errors.
+ * @param id Context id
+ * @return Error code.
+ */
+static inline int hound_context_id_err(hound_context_id_t id)
+{
+	return id > 0 ? EOK : (id == 0 ? ENOENT : id);
+}
+
 hound_sess_t *hound_service_connect(const char *service);
 void hound_service_disconnect(hound_sess_t *sess);
 
-errno_t hound_service_register_context(hound_sess_t *sess,
-    const char *name, bool record, hound_context_id_t *id);
-errno_t hound_service_unregister_context(hound_sess_t *sess, hound_context_id_t id);
+hound_context_id_t hound_service_register_context(hound_sess_t *sess,
+    const char *name, bool record);
+int hound_service_unregister_context(hound_sess_t *sess, hound_context_id_t id);
 
-errno_t hound_service_get_list(hound_sess_t *sess, char ***ids, size_t *count,
+int hound_service_get_list(hound_sess_t *sess, const char ***ids, size_t *count,
     int flags, const char *connection);
 
@@ -76,22 +86,22 @@
  * @return Error code.
  */
-static inline errno_t hound_service_get_list_all(hound_sess_t *sess,
-    char ***ids, size_t *count, int flags)
+static inline int hound_service_get_list_all(hound_sess_t *sess,
+    const char ***ids, size_t *count, int flags)
 {
 	return hound_service_get_list(sess, ids, count, flags, NULL);
 }
 
-errno_t hound_service_connect_source_sink(hound_sess_t *sess, const char *source,
+int hound_service_connect_source_sink(hound_sess_t *sess, const char *source,
     const char *sink);
-errno_t hound_service_disconnect_source_sink(hound_sess_t *sess, const char *source,
+int hound_service_disconnect_source_sink(hound_sess_t *sess, const char *source,
     const char *sink);
 
-errno_t hound_service_stream_enter(async_exch_t *exch, hound_context_id_t id,
+int hound_service_stream_enter(async_exch_t *exch, hound_context_id_t id,
     int flags, pcm_format_t format, size_t bsize);
-errno_t hound_service_stream_drain(async_exch_t *exch);
-errno_t hound_service_stream_exit(async_exch_t *exch);
+int hound_service_stream_drain(async_exch_t *exch);
+int hound_service_stream_exit(async_exch_t *exch);
 
-errno_t hound_service_stream_write(async_exch_t *exch, const void *data, size_t size);
-errno_t hound_service_stream_read(async_exch_t *exch, void *data, size_t size);
+int hound_service_stream_write(async_exch_t *exch, const void *data, size_t size);
+int hound_service_stream_read(async_exch_t *exch, void *data, size_t size);
 
 /* Server */
@@ -100,26 +110,26 @@
 typedef struct hound_server_iface {
 	/** Create new context */
-	errno_t (*add_context)(void *, hound_context_id_t *, const char *, bool);
+	int (*add_context)(void *, hound_context_id_t *, const char *, bool);
 	/** Destroy existing context */
-	errno_t (*rem_context)(void *, hound_context_id_t);
+	int (*rem_context)(void *, hound_context_id_t);
 	/** Query context direction */
 	bool (*is_record_context)(void *, hound_context_id_t);
 	/** Get string identifiers of specified objects */
-	errno_t (*get_list)(void *, char ***, size_t *, const char *, int);
+	int (*get_list)(void *, const char ***, size_t *, const char *, int);
 	/** Create connection between source and sink */
-	errno_t (*connect)(void *, const char *, const char *);
+	int (*connect)(void *, const char *, const char *);
 	/** Destroy connection between source and sink */
-	errno_t (*disconnect)(void *, const char *, const char *);
+	int (*disconnect)(void *, const char *, const char *);
 	/** Create new stream tied to the context */
-	errno_t (*add_stream)(void *, hound_context_id_t, int, pcm_format_t, size_t,
+	int (*add_stream)(void *, hound_context_id_t, int, pcm_format_t, size_t,
 	    void **);
 	/** Destroy existing stream */
-	errno_t (*rem_stream)(void *, void *);
+	int (*rem_stream)(void *, void *);
 	/** Block until the stream buffer is empty */
-	errno_t (*drain_stream)(void *);
+	int (*drain_stream)(void *);
 	/** Write new data to the stream */
-	errno_t (*stream_data_write)(void *, const void *, size_t);
+	int (*stream_data_write)(void *, const void *, size_t);
 	/** Read data from the stream */
-	errno_t (*stream_data_read)(void *, void *, size_t);
+	int (*stream_data_read)(void *, void *, size_t);
 	void *server;
 } hound_server_iface_t;
Index: uspace/lib/hound/include/hound/server.h
===================================================================
--- uspace/lib/hound/include/hound/server.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/hound/include/hound/server.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,10 +41,10 @@
 
 typedef void (*dev_change_callback_t)(void);
-typedef errno_t (*device_callback_t)(service_id_t, const char *);
+typedef int (*device_callback_t)(service_id_t, const char *);
 
-errno_t hound_server_register(const char *name, service_id_t *id);
+int hound_server_register(const char *name, service_id_t *id);
 void hound_server_unregister(service_id_t id);
-errno_t hound_server_set_device_change_callback(dev_change_callback_t cb);
-errno_t hound_server_devices_iterate(device_callback_t callback);
+int hound_server_set_device_change_callback(dev_change_callback_t cb);
+int hound_server_devices_iterate(device_callback_t callback);
 
 #endif
Index: uspace/lib/hound/src/client.c
===================================================================
--- uspace/lib/hound/src/client.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/hound/src/client.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -76,5 +76,5 @@
 	hound_sess_t *session;
 	/** context name, reported to the daemon */
-	char *name;
+	const char *name;
 	/** True if the instance is record context */
 	bool record;
@@ -123,8 +123,7 @@
 			return NULL;
 		}
-		errno_t rc = hound_service_register_context(
-		    new_context->session, new_context->name, record,
-		    &new_context->id);
-		if (rc != EOK) {
+		new_context->id = hound_service_register_context(
+		    new_context->session, new_context->name, record);
+		if (hound_context_id_err(new_context->id) != EOK) {
 			hound_service_disconnect(new_context->session);
 			free(new_context->name);
@@ -195,6 +194,6 @@
  * The function will return deice sinks or source based on the context type.
  */
-errno_t hound_context_get_available_targets(hound_context_t *hound,
-    char ***names, size_t *count)
+int hound_context_get_available_targets(hound_context_t *hound,
+    const char ***names, size_t *count)
 {
 	assert(hound);
@@ -212,6 +211,6 @@
  * @return Error code.
  */
-errno_t hound_context_get_connected_targets(hound_context_t *hound,
-    char ***names, size_t *count)
+int hound_context_get_connected_targets(hound_context_t *hound,
+    const char ***names, size_t *count)
 {
 	assert(hound);
@@ -232,12 +231,12 @@
  * connect to the first possible target if it is passed this value.
  */
-errno_t hound_context_connect_target(hound_context_t *hound, const char* target)
+int hound_context_connect_target(hound_context_t *hound, const char* target)
 {
 	assert(hound);
 	assert(target);
 
-	char **tgt = NULL;
+	const char **tgt = NULL;
 	size_t count = 1;
-	errno_t ret = EOK;
+	int ret = EOK;
 	if (str_cmp(target, HOUND_DEFAULT_TARGET) == 0) {
 		ret = hound_context_get_available_targets(hound, &tgt, &count);
@@ -269,5 +268,5 @@
  * @return Error code.
  */
-errno_t hound_context_disconnect_target(hound_context_t *hound, const char* target)
+int hound_context_disconnect_target(hound_context_t *hound, const char* target)
 {
 	assert(hound);
@@ -305,5 +304,5 @@
 		new_stream->context = hound;
 		new_stream->flags = flags;
-		const errno_t ret = hound_service_stream_enter(new_stream->exch,
+		const int ret = hound_service_stream_enter(new_stream->exch,
 		    hound->id, flags, format, bsize);
 		if (ret != EOK) {
@@ -343,5 +342,5 @@
  * @return error code.
  */
-errno_t hound_stream_write(hound_stream_t *stream, const void *data, size_t size)
+int hound_stream_write(hound_stream_t *stream, const void *data, size_t size)
 {
 	assert(stream);
@@ -358,5 +357,5 @@
  * @return error code.
  */
-errno_t hound_stream_read(hound_stream_t *stream, void *data, size_t size)
+int hound_stream_read(hound_stream_t *stream, void *data, size_t size)
 {
 	assert(stream);
@@ -371,5 +370,5 @@
  * @return Error code.
  */
-errno_t hound_stream_drain(hound_stream_t *stream)
+int hound_stream_drain(hound_stream_t *stream)
 {
 	assert(stream);
@@ -402,5 +401,5 @@
  * @return error code.
  */
-errno_t hound_write_main_stream(hound_context_t *hound,
+int hound_write_main_stream(hound_context_t *hound,
     const void *data, size_t size)
 {
@@ -422,5 +421,5 @@
  * @return error code.
  */
-errno_t hound_read_main_stream(hound_context_t *hound, void *data, size_t size)
+int hound_read_main_stream(hound_context_t *hound, void *data, size_t size)
 {
 	assert(hound);
@@ -442,5 +441,5 @@
  * NOT IMPLEMENTED
  */
-errno_t hound_write_replace_main_stream(hound_context_t *hound,
+int hound_write_replace_main_stream(hound_context_t *hound,
     const void *data, size_t size)
 {
@@ -460,5 +459,5 @@
  * NOT IMPLEMENTED
  */
-errno_t hound_context_set_main_stream_params(hound_context_t *hound,
+int hound_context_set_main_stream_params(hound_context_t *hound,
     pcm_format_t format, size_t bsize)
 {
@@ -479,5 +478,5 @@
  * to drain and destroys it before returning.
  */
-errno_t hound_write_immediate(hound_context_t *hound, pcm_format_t format,
+int hound_write_immediate(hound_context_t *hound, pcm_format_t format,
     const void *data, size_t size)
 {
@@ -488,5 +487,5 @@
 	if (!tmpstream)
 		return ENOMEM;
-	const errno_t ret = hound_stream_write(tmpstream, data, size);
+	const int ret = hound_stream_write(tmpstream, data, size);
 	if (ret == EOK) {
 		//TODO drain?
Index: uspace/lib/hound/src/protocol.c
===================================================================
--- uspace/lib/hound/src/protocol.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/hound/src/protocol.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -93,5 +93,5 @@
 {
 	service_id_t id = 0;
-	const errno_t ret =
+	const int ret =
 	    loc_service_get_id(service, &id, IPC_FLAG_BLOCKING);
 	if (ret != EOK)
@@ -115,11 +115,8 @@
  * @param name Valid string identifier
  * @param record True if the application context wishes to receive data.
- *
- * @param[out] id  Return context ID.
- *
- * @return EOK on success, Error code on failure.
- */
-errno_t hound_service_register_context(hound_sess_t *sess,
-    const char *name, bool record, hound_context_id_t *id)
+ * @return Valid ID on success, Error code on failure.
+ */
+hound_context_id_t hound_service_register_context(hound_sess_t *sess,
+    const char *name, bool record)
 {
 	assert(sess);
@@ -129,5 +126,5 @@
 	aid_t mid =
 	    async_send_1(exch, IPC_M_HOUND_CONTEXT_REGISTER, record, &call);
-	errno_t ret = mid ? EOK : EPARTY;
+	int ret = mid ? EOK : EPARTY;
 
 	if (ret == EOK)
@@ -137,12 +134,8 @@
 
 	if (ret == EOK)
-		async_wait_for(mid, &ret);
+		async_wait_for(mid, (sysarg_t *)&ret);
 
 	async_exchange_end(exch);
-	if (ret == EOK) {
-		*id = (hound_context_id_t)IPC_GET_ARG1(call);
-	}
-
-	return ret;
+	return ret == EOK ? (hound_context_id_t)IPC_GET_ARG1(call) : ret;
 }
 
@@ -153,9 +146,9 @@
  * @return Error code.
  */
-errno_t hound_service_unregister_context(hound_sess_t *sess, hound_context_id_t id)
+int hound_service_unregister_context(hound_sess_t *sess, hound_context_id_t id)
 {
 	assert(sess);
 	async_exch_t *exch = async_exchange_begin(sess);
-	const errno_t ret =
+	const int ret =
 	    async_req_1_0(exch, IPC_M_HOUND_CONTEXT_UNREGISTER, id);
 	async_exchange_end(exch);
@@ -173,5 +166,5 @@
  * @retval Error code.
  */
-errno_t hound_service_get_list(hound_sess_t *sess, char ***ids, size_t *count,
+int hound_service_get_list(hound_sess_t *sess, const char ***ids, size_t *count,
     int flags, const char *connection)
 {
@@ -189,7 +182,7 @@
 	ipc_call_t res_call;
 	aid_t mid = async_send_3(exch, IPC_M_HOUND_GET_LIST, flags, *count,
-	    connection != NULL, &res_call);
-
-	errno_t ret = EOK;
+	    (bool)connection, &res_call);
+
+	int ret = EOK;
 	if (mid && connection)
 		ret = async_data_write_start(exch, connection,
@@ -197,5 +190,5 @@
 
 	if (ret == EOK)
-		async_wait_for(mid, &ret);
+		async_wait_for(mid, (sysarg_t*)&ret);
 
 	if (ret != EOK) {
@@ -206,5 +199,5 @@
 
 	/* Start receiving names */
-	char **names = NULL;
+	const char **names = NULL;
 	if (name_count) {
 		size_t *sizes = calloc(name_count, sizeof(size_t));
@@ -247,5 +240,5 @@
  * @return Error code.
  */
-errno_t hound_service_connect_source_sink(hound_sess_t *sess, const char *source,
+int hound_service_connect_source_sink(hound_sess_t *sess, const char *source,
     const char *sink)
 {
@@ -259,10 +252,10 @@
 	ipc_call_t call;
 	aid_t id = async_send_0(exch, IPC_M_HOUND_CONNECT, &call);
-	errno_t ret = id ? EOK : EPARTY;
+	int ret = id ? EOK : EPARTY;
 	if (ret == EOK)
 		ret = async_data_write_start(exch, source, str_size(source));
 	if (ret == EOK)
 		ret = async_data_write_start(exch, sink, str_size(sink));
-	async_wait_for(id, &ret);
+	async_wait_for(id, (sysarg_t*)&ret);
 	async_exchange_end(exch);
 	return ret;
@@ -276,5 +269,5 @@
  * @return Error code.
  */
-errno_t hound_service_disconnect_source_sink(hound_sess_t *sess, const char *source,
+int hound_service_disconnect_source_sink(hound_sess_t *sess, const char *source,
     const char *sink)
 {
@@ -285,10 +278,10 @@
 	ipc_call_t call;
 	aid_t id = async_send_0(exch, IPC_M_HOUND_DISCONNECT, &call);
-	errno_t ret = id ? EOK : EPARTY;
+	int ret = id ? EOK : EPARTY;
 	if (ret == EOK)
 		ret = async_data_write_start(exch, source, str_size(source));
 	if (ret == EOK)
 		ret = async_data_write_start(exch, sink, str_size(sink));
-	async_wait_for(id, &ret);
+	async_wait_for(id, (sysarg_t*)&ret);
 	async_exchange_end(exch);
 	return ENOTSUP;
@@ -304,5 +297,5 @@
  * @return Error code.
  */
-errno_t hound_service_stream_enter(async_exch_t *exch, hound_context_id_t id,
+int hound_service_stream_enter(async_exch_t *exch, hound_context_id_t id,
     int flags, pcm_format_t format, size_t bsize)
 {
@@ -321,5 +314,5 @@
  * @return Error code.
  */
-errno_t hound_service_stream_exit(async_exch_t *exch)
+int hound_service_stream_exit(async_exch_t *exch)
 {
 	return async_req_0_0(exch, IPC_M_HOUND_STREAM_EXIT);
@@ -331,5 +324,5 @@
  * @return Error code.
  */
-errno_t hound_service_stream_drain(async_exch_t *exch)
+int hound_service_stream_drain(async_exch_t *exch)
 {
 	return async_req_0_0(exch, IPC_M_HOUND_STREAM_DRAIN);
@@ -343,5 +336,5 @@
  * @return Error code.
  */
-errno_t hound_service_stream_write(async_exch_t *exch, const void *data, size_t size)
+int hound_service_stream_write(async_exch_t *exch, const void *data, size_t size)
 {
 	return async_data_write_start(exch, data, size);
@@ -355,5 +348,5 @@
  * @return Error code.
  */
-errno_t hound_service_stream_read(async_exch_t *exch, void *data, size_t size)
+int hound_service_stream_read(async_exch_t *exch, void *data, size_t size)
 {
 	return async_data_read_start(exch, data, size);
@@ -407,5 +400,5 @@
 
 			/* Get context name */
-			errno_t ret =
+			int ret =
 			    async_data_write_accept(&name, true, 0, 0, 0, 0);
 			if (ret != EOK) {
@@ -434,5 +427,5 @@
 			/* get id, 1st param */
 			hound_context_id_t id = IPC_GET_ARG1(call);
-			const errno_t ret =
+			const int ret =
 			    server_iface->rem_context(server_iface->server, id);
 			async_answer_0(callid, ret);
@@ -446,10 +439,10 @@
 			}
 
-			char **list = NULL;
+			const char **list = NULL;
 			const int flags = IPC_GET_ARG1(call);
 			size_t count = IPC_GET_ARG2(call);
 			const bool conn = IPC_GET_ARG3(call);
 			char *conn_name = NULL;
-			errno_t ret = EOK;
+			int ret = EOK;
 
 			/* get connected actor name if provided */
@@ -513,5 +506,5 @@
 
 			/* read source name */
-			errno_t ret =
+			int ret =
 			    async_data_write_accept(&source, true, 0, 0, 0, 0);
 			/* read sink name */
@@ -539,5 +532,5 @@
 
 			/* read source name */
-			errno_t ret =
+			int ret =
 			    async_data_write_accept(&source, true, 0, 0, 0, 0);
 			/*read sink name */
@@ -574,5 +567,5 @@
 
 			void *stream;
-			errno_t ret = server_iface->add_stream(server_iface->server,
+			int ret = server_iface->add_stream(server_iface->server,
 			    id, flags, f, bsize, &stream);
 			if (ret != EOK) {
@@ -626,5 +619,5 @@
 	ipc_call_t call;
 	size_t size = 0;
-	errno_t ret_answer = EOK;
+	int ret_answer = EOK;
 	/* accept data write or drain */
 	while (async_data_write_receive_call(&callid, &call, &size)
@@ -632,5 +625,5 @@
 		/* check drain first */
 		if (IPC_GET_IMETHOD(call) == IPC_M_HOUND_STREAM_DRAIN) {
-			errno_t ret = ENOTSUP;
+			int ret = ENOTSUP;
 			if (server_iface->drain_stream)
 				ret = server_iface->drain_stream(stream);
@@ -650,5 +643,5 @@
 			continue;
 		}
-		const errno_t ret = async_data_write_finalize(callid, buffer, size);
+		const int ret = async_data_write_finalize(callid, buffer, size);
 		if (ret == EOK) {
 			/* push data to stream */
@@ -657,5 +650,5 @@
 		}
 	}
-	const errno_t ret = IPC_GET_IMETHOD(call) == IPC_M_HOUND_STREAM_EXIT
+	const int ret = IPC_GET_IMETHOD(call) == IPC_M_HOUND_STREAM_EXIT
 	    ? EOK : EINVAL;
 
@@ -673,5 +666,5 @@
 	ipc_call_t call;
 	size_t size = 0;
-	errno_t ret_answer = EOK;
+	int ret_answer = EOK;
 	/* accept data read and drain */
 	while (async_data_read_receive_call(&callid, &call, &size)
@@ -679,5 +672,5 @@
 		/* drain does not make much sense but it is allowed */
 		if (IPC_GET_IMETHOD(call) == IPC_M_HOUND_STREAM_DRAIN) {
-			errno_t ret = ENOTSUP;
+			int ret = ENOTSUP;
 			if (server_iface->drain_stream)
 				ret = server_iface->drain_stream(stream);
@@ -695,5 +688,5 @@
 			continue;
 		}
-		errno_t ret = server_iface->stream_data_read(stream, buffer, size);
+		int ret = server_iface->stream_data_read(stream, buffer, size);
 		if (ret == EOK) {
 			ret_answer =
@@ -701,5 +694,5 @@
 		}
 	}
-	const errno_t ret = IPC_GET_IMETHOD(call) == IPC_M_HOUND_STREAM_EXIT
+	const int ret = IPC_GET_IMETHOD(call) == IPC_M_HOUND_STREAM_EXIT
 	    ? EOK : EINVAL;
 
@@ -718,10 +711,10 @@
  * @return Error code.
  */
-errno_t hound_server_register(const char *name, service_id_t *id)
+int hound_server_register(const char *name, service_id_t *id)
 {
 	if (!name || !id)
 		return EINVAL;
 
-	errno_t ret = loc_server_register(name);
+	int ret = loc_server_register(name);
 	if (ret != EOK)
 		return ret;
@@ -744,5 +737,5 @@
  * @return Error code.
  */
-errno_t hound_server_set_device_change_callback(dev_change_callback_t cb)
+int hound_server_set_device_change_callback(dev_change_callback_t cb)
 {
 	return loc_register_cat_change_cb(cb);
@@ -754,5 +747,5 @@
  * @return Error code.
  */
-errno_t hound_server_devices_iterate(device_callback_t callback)
+int hound_server_devices_iterate(device_callback_t callback)
 {
 	if (!callback)
@@ -762,5 +755,5 @@
 
 	if (!resolved) {
-		const errno_t ret = loc_category_get_id("audio-pcm", &cat_id,
+		const int ret = loc_category_get_id("audio-pcm", &cat_id,
 		    IPC_FLAG_BLOCKING);
 		if (ret != EOK)
@@ -771,5 +764,5 @@
 	service_id_t *svcs = NULL;
 	size_t count = 0;
-	const errno_t ret = loc_category_get_svcs(cat_id, &svcs, &count);
+	const int ret = loc_category_get_svcs(cat_id, &svcs, &count);
 	if (ret != EOK)
 		return ret;
